using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Baby3dx
{
   public class TestControl : Control
   {
      private int painted;
      private int resized;
      public string name = "Viewer";

      public TestControl()
      {
         SetStyle(ControlStyles.DoubleBuffer, true);
         SetStyle(ControlStyles.Opaque, true);
         SetStyle(ControlStyles.UserPaint, true);
         SetStyle(ControlStyles.AllPaintingInWmPaint, true);
         SetStyle(ControlStyles.ResizeRedraw, true);        
         Size = new Size(100, 100);
      }

      protected override void OnPaint(PaintEventArgs e)
      {
         base.OnPaint(e);
         e.Graphics.Clear(Color.White);
         e.Graphics.DrawString("Painted: " + ++painted, Font, Brushes.Black, 10, 10);
         e.Graphics.DrawString("Resized: " + resized, Font, Brushes.Black, 10, 30);
         e.Graphics.DrawString(name, Font, Brushes.Black, 10, 50);
      }


      protected override void OnResize(EventArgs e)
      {
         base.OnResize(e);
         resized++;
      }
   }
}
